2 # Bootstrap a Drupal project
4 # Copyright (C) 2017 Antonio Ospite <ao2@ao2.it>
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 2 of the License, or
9 # (at your option) any later version.
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
16 # You should have received a copy of the GNU General Public License
17 # along with this program. If not, see <http://www.gnu.org/licenses/>.
23 usage: drin $(basename "$0" .sh) [--devel|--overwrite-profile|-h|--help]
25 Bootstrap a Drupal project, using settings from a 'bootstrap.conf' file.
28 --devel install drupal/devel and use a settings.local.php file
29 --overwrite-profile allow overwriting the current installation profile
30 -h, --help display this usage message and exit
46 OVERWRITE_PROFILE="true"
49 echo "Error: Unknown option '${1}'" 1>&2
55 [ -f "bootstrap.conf" ] || { echo "Aborting, run this command from the Drupal project directory." 1>&2; exit 1; }
57 # shellcheck disable=SC1091
64 declare -p ACCOUNT_NAME
65 declare -p ACCOUNT_PASS
66 declare -p ACCOUNT_MAIL
70 declare -p SITE_BASE_PATH
72 declare -p TRUSTED_HOSTS
74 declare -p WEB_SERVER_GROUP
76 [ "x$INSTALLATION_PROFILE" = "x" ] && { echo "INSTALLATION_PROFILE not specified, using the \"standard\" profile!"; INSTALLATION_PROFILE="standard"; }
78 if [ "x$MYSQL_ROOT_PASSWORD" = "x" ];
80 read -r -s -p "MySQL root password: " MYSQL_ROOT_PASSWORD
86 command -v composer &> /dev/null || { echo "Aborting, 'composer' not available." 1>&2; exit 1; }
87 command -v git &> /dev/null || { echo "Aborting, 'git' not available." 1>&2; exit 1; }
89 [ -d "$WEB_ROOT" ] || composer install
91 DRUSH="${PWD}/vendor/bin/drush"
92 DRUPAL_CONSOLE="${PWD}/vendor/bin/drupal"
94 [ -x "$DRUSH" ] || { echo "Aborting, '$DRUSH' not available." 1>&2; exit 1; }
95 [ -x "$DRUPAL_CONSOLE" ] || { echo "Aborting, '$DRUPAL_CONSOLE' not available." 1>&2; exit 1; }
97 # This becomes unnecessary if the installation profile gets pulled in by
98 # composer.json, like suggested in
99 # https://github.com/drupal-composer/drupal-project/issues/249
100 if ! echo "$INSTALLATION_PROFILE" | grep -q -E "^(minimal|standard)$";
102 if [ -d "${WEB_ROOT}/profiles/${INSTALLATION_PROFILE}" ] && [ "$OVERWRITE_PROFILE" != "true" ];
104 echo "Installation profile '$INSTALLATION_PROFILE' already there." 1>&2
105 echo "Use --overwrite-profile to copy over it." 1>&2
108 cp -a "$INSTALLATION_PROFILE" "${WEB_ROOT}/profiles"
114 # Update the install_profile if it's already there
115 if grep -q "^\\\$settings\['install_profile'\] =" sites/default/settings.php;
117 chmod 755 sites/default
118 chmod 644 sites/default/settings.php
119 sed -i -e "s/^\(\$settings\['install_profile'\]\) = '[^']*';/\1 = '$INSTALLATION_PROFILE';/g" sites/default/settings.php
120 chmod 444 sites/default/settings.php
121 chmod 555 sites/default
124 $DRUSH --verbose --yes \
127 --db-su-pw="$MYSQL_ROOT_PASSWORD" \
128 --db-url="mysql://${DB_USER}:${DB_PASS}@localhost/${DB_NAME}" \
129 --site-name="$SITE_NAME" \
130 --site-mail="$SITE_MAIL" \
131 --account-name="$ACCOUNT_NAME" \
132 --account-pass="$ACCOUNT_PASS" \
133 --account-mail="$ACCOUNT_MAIL" \
134 "$INSTALLATION_PROFILE"
136 if $DRUSH pm-info --fields=status locale | grep -q enabled;
138 # This is necessary for multi-language sites, it fixes some issues like:
139 # "The Translation source field needs to be installed."
140 $DRUSH --yes entity-updates
142 # Update translations of contrib modules
143 $DRUSH --yes locale-update
146 # This fixes permissions when installing under $HOME/public_html/
147 chmod 775 sites/default/files
148 sudo chgrp -R "$WEB_SERVER_GROUP" sites/default/files
150 [ -d ../config/sync ] && sudo chgrp -R "$WEB_SERVER_GROUP" ../config/sync
153 sed -i "s@\(# \)\{0,1\}RewriteBase .*\$@RewriteBase ${SITE_BASE_PATH}@" .htaccess
155 chmod 755 sites/default
156 chmod 644 sites/default/settings.php
158 # Add some basic settings to settings.php
159 if ! grep -q "^\\\$settings\['trusted_host_patterns'\] =" sites/default/settings.php;
161 echo "\$settings['trusted_host_patterns'] = [" >> sites/default/settings.php
162 for host in "${TRUSTED_HOSTS[@]}"
164 echo " '^${host}\$'," >> sites/default/settings.php
166 echo "];" >> sites/default/settings.php
169 if [ "$DEVEL_MODE" = "true" ];
171 # NOTE: don't run composer under web/ but in the project dir
172 composer --working-dir=../ require drupal/devel
173 $DRUSH --yes en devel
175 if [ ! -e sites/default/settings.local.php ];
177 cp sites/example.settings.local.php sites/default/settings.local.php
179 # Disable some overly permissive settings
180 sed -i -e "s/^\(\$settings\['rebuild_access'\]\).*$/\1 = FALSE;/g" sites/default/settings.local.php
181 sed -i -e "s/^\(\$settings\['skip_permissions_hardening'\]\).*$/\1 = FALSE;/g" sites/default/settings.local.php
183 chmod 444 sites/default/settings.local.php
186 if ! grep -q "^include \$app_root . '/' . \$site_path . '/settings.local.php';" sites/default/settings.php;
188 echo "include \$app_root . '/' . \$site_path . '/settings.local.php';" >> sites/default/settings.php
192 chmod 444 sites/default/settings.php
193 chmod 555 sites/default
195 # If using a git checkout of Drupal core, set up a diff alias.
197 # This is useful because the Automated Test infrastructure of drupal.org does
198 # not expect patches to be created from a split core directory.
201 git -C core/ config --local alias.core-diff "diff --src-prefix=a/core/ --dst-prefix=b/core/"
202 echo "Added a 'git core-diff' to the drupal/core repository clone."
203 echo "This command helps creating core patches ready for upstream."